## libslirp 4.1.0

=== Makefile ===
ROOT_DIR := $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
BUILD_DIR ?= .

LIBSLIRP = $(BUILD_DIR)/libslirp.a
SLIRP_MAJOR_VERSION = 4
SLIRP_MINOR_VERSION = 1
SLIRP_MICRO_VERSION = 0

all: $(LIBSLIRP)

SRCS := $(wildcard src/*.c)
OBJS := $(SRCS:%.c=$(BUILD_DIR)/%.o)
DEPS := $(OBJS:%.o=%.d)

INC_DIRS := $(BUILD_DIR)/src
INC_FLAGS := $(addprefix -I,$(INC_DIRS))

override CFLAGS +=					\
	-DG_LOG_DOMAIN='"Slirp"'			\
	$(shell $(PKG_CONFIG) --cflags glib-2.0)	\
	$(INC_FLAGS)					\
	-MMD -MP
override LDFLAGS += $(shell $(PKG_CONFIG) --libs glib-2.0)

$(BUILD_DIR)/src/libslirp-version.h:
	@$(MKDIR_P) $(dir $@)
	$(call quiet-command,cat $(ROOT_DIR)/src/libslirp-version.h.in | \
		sed 's/@SLIRP_MAJOR_VERSION@/$(SLIRP_MAJOR_VERSION)/' | \
		sed 's/@SLIRP_MINOR_VERSION@/$(SLIRP_MINOR_VERSION)/' | \
		sed 's/@SLIRP_MICRO_VERSION@/$(SLIRP_MICRO_VERSION)/' \
	> $@,"GEN","$@")

$(OBJS): $(BUILD_DIR)/src/libslirp-version.h

$(LIBSLIRP): $(OBJS)

.PHONY: clean

clean:
	rm -r $(OBJS) $(DEPS) $(LIBSLIRP) $(BUILD_DIR)/src/libslirp-version.h

$(BUILD_DIR)/src/%.o: $(ROOT_DIR)/src/%.c
	@$(MKDIR_P) $(dir $@)
	$(call quiet-command,$(CC) $(CFLAGS) -c -o $@ $<,"CC","$@")

%.a:
	$(call quiet-command,rm -f $@ && $(AR) rcs $@ $^,"AR","$@")

PKG_CONFIG ?= pkg-config
MKDIR_P ?= mkdir -p
quiet-command-run = $(if $(V),,$(if $2,printf "  %-7s %s\n" $2 $3 && ))$1
quiet-@ = $(if $(V),,@)
quiet-command = $(quiet-@)$(call quiet-command-run,$1,$2,$3)

print-%:
	@echo '$*=$($*)'

.SUFFIXES:

-include $(DEPS)

=== debian/changelog ===
libslirp (4.1.0-2ubuntu2.2) focal-security; urgency=medium

  * SECURITY UPDATE: DoS via buffer overread
    - debian/patches/CVE-2020-29129_30.patch: check pkt_len before reading
      protocol header in src/ncsi.c, src/slirp.c.
    - CVE-2020-29129
    - CVE-2020-29130
  * SECURITY UPDATE: data leak in bootp_input()
    - debian/patches/CVE-2021-3592-1.patch: add mtod_check() to src/mbuf.*.
    - debian/patches/CVE-2021-3592-2.patch: limit vendor-specific area to
      input packet memory buffer in src/bootp.*, src/mbuf.*.
    - debian/patches/CVE-2021-3592-3.patch: check bootp_input buffer size
      in src/bootp.c.
    - debian/patches/CVE-2021-3592-4.patch: fix regression in dhcp in
      src/bootp.c.
    - CVE-2021-3592
  * SECURITY UPDATE: data leak in udp6_input()
    - debian/patches/CVE-2021-3593.patch: check udp6_input buffer size in
      src/udp6.c.
    - CVE-2021-3593
  * SECURITY UPDATE: data leak in udp_input()
    - debian/patches/CVE-2021-3594.patch: check upd_input buffer size in
      src/udp.c.
    - CVE-2021-3594
  * SECURITY UPDATE: data leak in tftp_input()
    - debian/patches/CVE-2021-3595-1.patch: check tftp_input buffer size in
      src/tftp.c.
    - debian/patches/CVE-2021-3595-2.patch: introduce a header structure in
      src/tftp.*.
    - CVE-2021-3595

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 21 Jun 2021 08:43:06 -0400

libslirp (4.1.0-2ubuntu2.1) focal-security; urgency=medium

  * SECURITY UPDATE: OOB read in icmp6_send_echoreply()
    - debian/patches/CVE-2020-10756.patch: check message size in
      src/ip6_input.c.
    - CVE-2020-10756

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 23 Jul 2020 14:09:04 -0400

libslirp (4.1.0-2ubuntu2) focal; urgency=medium

  * SECURITY UPDATE: use-after-free in ip_reass()
    - debian/patches/CVE-2020-1983.patch: fix buffer handling in
      src/ip_input.c.
    - CVE-2020-1983

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 21 Apr 2020 07:18:28 -0400

libslirp (4.1.0-2ubuntu1) focal; urgency=medium

  * SECURITY UPDATE: buffer overflow via incorrect snprintf return codes
    - debian/patches/ubuntu/CVE-2020-8608-1.patch: add slirp_fmt() helpers
      to src/util.c, src/util.h.
    - debian/patches/ubuntu/CVE-2020-8608-2.patch: fix unsafe snprintf()
      usages in src/tcp_subr.c.
    - CVE-2020-8608

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 19 Feb 2020 08:57:46 -0500

libslirp (4.1.0-2) unstable; urgency=high

  * Closes: #949084, CVE-2020-7039:
    OOB buffer access while emulating tcp protocols in tcp_emu()
    This includes 3 patches:
     tcp_emu-fix-OOB-access-CVE-2020-7039.patch
     slirp-use-correct-size-while-emulating-commands-CVE-2020-7039.patch
     slirp-use-correct-size-while-emulating-IRC-commands-CVE-2020-7039.patch

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 17 Jan 2020 14:24:00 +0300

libslirp (4.1.0-1) unstable; urgency=medium

  * new upstream release (4.1.0)
  * remove all patches (now everything is included upstream)
  * included 2 new symbols to libslirp0.symbols

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 07 Dec 2019 16:10:42 +0300

libslirp (4.0.0-2) unstable; urgency=medium

  * fork_exec-correctly-parse-command-lines-that-contain-spaces.patch
  * bump Standards-Version to 4.4.1 (no changes)

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 28 Nov 2019 13:58:14 +0300

libslirp (4.0.0-1) unstable; urgency=medium

  * initial release

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 27 Aug 2019 15:55:43 +0300

=== debian/control ===
Source: libslirp
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: Michael Tokarev <mjt@tls.msk.ru>
Build-Depends: debhelper (>= 11~), libglib2.0-dev, meson, ninja-build
Standards-Version: 4.4.1
Homepage: https://gitlab.freedesktop.org/slirp/libslirp
Vcs-Browser: https://salsa.debian.org/qemu-team/libslirp
Vcs-Git: https://salsa.debian.org/qemu-team/libslirp.git

Package: libslirp0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: General purpose TCP-IP emulator library
 libslirp is a user-mode networking library used by virtual machines,
 containers or various tools.
 .
 This package contains the library itself.

Package: libslirp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libslirp0 (= ${binary:Version}), ${misc:Depends}
Description: General purpose TCP-IP emulator library (development files)
 libslirp is a user-mode networking library used by virtual machines,
 containers or various tools.
 .
 This package contains the header files and other files
 needed to compile applications which uses libslirp.

## libslirp 4.3.1

=== Makefile ===
--- 
+++ 
@@ -3,8 +3,9 @@
 
 LIBSLIRP = $(BUILD_DIR)/libslirp.a
 SLIRP_MAJOR_VERSION = 4
-SLIRP_MINOR_VERSION = 1
-SLIRP_MICRO_VERSION = 0
+SLIRP_MINOR_VERSION = 3
+SLIRP_MICRO_VERSION = 1
+SLIRP_VERSION_STRING = "$(SLIRP_MAJOR_VERSION).$(SLIRP_MINOR_VERSION).$(SLIRP_MICRO_VERSION)-git"
 
 all: $(LIBSLIRP)
 
@@ -22,12 +23,13 @@
 	-MMD -MP
 override LDFLAGS += $(shell $(PKG_CONFIG) --libs glib-2.0)
 
-$(BUILD_DIR)/src/libslirp-version.h:
+$(BUILD_DIR)/src/libslirp-version.h: Makefile
 	@$(MKDIR_P) $(dir $@)
 	$(call quiet-command,cat $(ROOT_DIR)/src/libslirp-version.h.in | \
 		sed 's/@SLIRP_MAJOR_VERSION@/$(SLIRP_MAJOR_VERSION)/' | \
 		sed 's/@SLIRP_MINOR_VERSION@/$(SLIRP_MINOR_VERSION)/' | \
-		sed 's/@SLIRP_MICRO_VERSION@/$(SLIRP_MICRO_VERSION)/' \
+		sed 's/@SLIRP_MICRO_VERSION@/$(SLIRP_MICRO_VERSION)/' | \
+		sed 's/@SLIRP_VERSION_STRING@/$(SLIRP_VERSION_STRING)/' \
 	> $@,"GEN","$@")
 
 $(OBJS): $(BUILD_DIR)/src/libslirp-version.h

=== debian/changelog ===
libslirp (4.3.1-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports (no changes).

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 23 Jul 2020 15:14:29 +0300

libslirp (4.3.1-1) unstable; urgency=medium

  * new upstream release
   - fix CVE-2020-10756 - Drop bogus IPv6 messages
     that could lead to data leakage
   - various coverity scan errors fixed
  * remove fixes which are now included upstream
  * use versioned build-depends on meson (>= 0.49) as per upstream
  * fix slirp_new version in d/libslirp0.symbols

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 03 Jul 2020 18:47:12 +0300

libslirp (4.2.0-2) unstable; urgency=high

  * slirp-fix-use-afte-free-in-ip_reass-CVE-2020-1983.patch
    another use-after-free in ip_reass() fix
    Closes: CVE-2020-1983

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 21 Apr 2020 09:47:57 +0300

libslirp (4.2.0-1) unstable; urgency=medium

  * new upstream release (Closes: CVE-2020-8608)
  * remove all patches (everything's included upstream)
  * update symbols file

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 14 Apr 2020 17:37:37 +0300

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: libslirp
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
+Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
 Uploaders: Michael Tokarev <mjt@tls.msk.ru>
-Build-Depends: debhelper (>= 11~), libglib2.0-dev, meson, ninja-build
+Build-Depends: debhelper (>= 11~), libglib2.0-dev, meson (>> 0.49~), ninja-build
 Standards-Version: 4.4.1
 Homepage: https://gitlab.freedesktop.org/slirp/libslirp
 Vcs-Browser: https://salsa.debian.org/qemu-team/libslirp

## libslirp 4.4.0

=== debian/changelog ===
libslirp (4.4.0-1ubuntu0.1) hirsute-security; urgency=medium

  * SECURITY UPDATE: data leak in bootp_input()
    - debian/patches/CVE-2021-3592-1.patch: add mtod_check() to src/mbuf.*.
    - debian/patches/CVE-2021-3592-2.patch: limit vendor-specific area to
      input packet memory buffer in src/bootp.*, src/mbuf.*.
    - debian/patches/CVE-2021-3592-3.patch: check bootp_input buffer size
      in src/bootp.c.
    - debian/patches/CVE-2021-3592-4.patch: fix regression in dhcp in
      src/bootp.c.
    - CVE-2021-3592
  * SECURITY UPDATE: data leak in udp6_input()
    - debian/patches/CVE-2021-3593.patch: check udp6_input buffer size in
      src/udp6.c.
    - CVE-2021-3593
  * SECURITY UPDATE: data leak in udp_input()
    - debian/patches/CVE-2021-3594.patch: check upd_input buffer size in
      src/udp.c.
    - CVE-2021-3594
  * SECURITY UPDATE: data leak in tftp_input()
    - debian/patches/CVE-2021-3595-1.patch: check tftp_input buffer size in
      src/tftp.c.
    - debian/patches/CVE-2021-3595-2.patch: introduce a header structure in
      src/tftp.*.
    - CVE-2021-3595

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 21 Jun 2021 08:25:24 -0400

libslirp (4.4.0-1) unstable; urgency=medium

  * new upstream release
    Closes: CVE-2020-29129, CVE-2020-29130
    (2e1dcbc0c2af64fcb17009eaf2ceedd81be2b27f)
  * bump standards-version to 4.5.1 (no changes)
  * switch from d/compat to debhelper-compat=12
  * use secure (https) URL in d/copyright
  * d/control: Rules-Requires-Root: no
  * add Build-Depends-Package field to d/libslirp0.symbols

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 19 Dec 2020 18:36:33 +0300

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,12 @@
 Source: libslirp
 Section: net
 Priority: optional
-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
 Uploaders: Michael Tokarev <mjt@tls.msk.ru>
-Build-Depends: debhelper (>= 11~), libglib2.0-dev, meson (>> 0.49~), ninja-build
-Standards-Version: 4.4.1
+Build-Depends: debhelper-compat (= 12), libglib2.0-dev, meson (>> 0.49~), ninja-build
+Standards-Version: 4.5.1
+Rules-Requires-Root: no
 Homepage: https://gitlab.freedesktop.org/slirp/libslirp
 Vcs-Browser: https://salsa.debian.org/qemu-team/libslirp
 Vcs-Git: https://salsa.debian.org/qemu-team/libslirp.git
@@ -32,4 +34,3 @@
  .
  This package contains the header files and other files
  needed to compile applications which uses libslirp.
-

## libslirp 4.6.1

=== debian/changelog ===
libslirp (4.6.1-1ubuntu0.1) jammy; urgency=medium

  * d/rules, d/libslirp-dev.install: ship static library in the libslirp-dev
    binary package. (LP: #2029431)

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Wed, 03 Jan 2024 07:54:40 +0100

libslirp (4.6.1-1build1) jammy; urgency=high

  * No change rebuild for ppc64el baseline bump.

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 24 Mar 2022 17:13:49 +0100

libslirp (4.6.1-1) unstable; urgency=medium

  * import v4.6.1 upstream release
    Closes: #989993, CVE-2021-3592
    Closes: #989994, CVE-2021-3593
    Closes: #989995, CVE-2021-3594
    Closes: #989996, CVE-2021-3595
  * Updated d/libslirp0.symbols with new symbols (from 4.5 release)
  * Updated Standards-Version to 4.6.0 (no changes)
  * Bump debhelper-compat to 13
  * Remove version from meson build-dependency (buster+)

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 19 Aug 2021 16:39:43 +0300

=== debian/rules ===
#! /usr/bin/make -f

build-arch build-indep build clean install-indep install-arch install binary-arch binary-indep binary: %:
	dh $@ --buildsystem=meson+ninja

override_dh_auto_configure:
	dh_auto_configure -- --default-library=both

## libslirp 4.7.0

=== debian/changelog ===
libslirp (4.7.0-1) unstable; urgency=medium

  * new upstream release
  * libslirp0.symbols: add slirp_handle_timer
  * add gbp.conf (list just upstream-vcs-tag=);
    switched to default gbp naming scheme in tags and branches

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 01 May 2022 00:13:57 +0300

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: libslirp
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
+Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
 Uploaders: Michael Tokarev <mjt@tls.msk.ru>
-Build-Depends: debhelper-compat (= 12), libglib2.0-dev, meson (>> 0.49~), ninja-build
-Standards-Version: 4.5.1
+Build-Depends: debhelper-compat (= 13), libglib2.0-dev, meson, ninja-build
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://gitlab.freedesktop.org/slirp/libslirp
 Vcs-Browser: https://salsa.debian.org/qemu-team/libslirp

=== debian/rules ===
#! /usr/bin/make -f

build-arch build-indep build clean install-indep install-arch install binary-arch binary-indep binary: %:
	dh $@ --buildsystem=meson+ninja

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/libslirp-v(\d\S+)\.tar\.bz2/libslirp-$1\.tar\.bz2/g \
  https://gitlab.freedesktop.org/slirp/libslirp/tags?sort=updated_desc .*/archive/v(\d[^-]+)/.*\.tar\.bz2.*

## libslirp 4.8.0

=== debian/changelog ===
libslirp (4.8.0-1ubuntu1) oracular; urgency=medium

  * Merge with Debian unstable (LP: #2064421). Remaining changes:
    - d/rules, d/libslirp-dev.install: ship static library in the libslirp-dev
      binary package. (LP #2029431)

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 27 Jun 2024 08:38:05 +0200

libslirp (4.8.0-1) unstable; urgency=medium

  [ Michael Tokarev ]
  * new upstream release
    Closes: #963797 (dns does not work without resolv.conf)
  * d/changelog: add Closes: #1003450 to the previous changelog entry
  * d/watch: update for gitlab changes
  * d/rules: stop overriding dh_auto_confogure -Ddisable_tests
    (not needed anymore)
  * d/control: Standards-Version: 4.7.0 (no changes needed)

  [ Janitor ]
  * Use versioned copyright format URI.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

  [ Helmut Grohne ]
  * Fix FTCBFS: Disable tests for DEB_BUILD_OPTIONS=nocheck. (Closes: #981893)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 16 Jun 2024 18:17:55 +0300

libslirp (4.7.0-1ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:37:44 +0000

libslirp (4.7.0-1ubuntu2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:29:38 +0000

libslirp (4.7.0-1ubuntu1) mantic; urgency=medium

  * d/rules, d/libslirp-dev.install: ship static library in the libslirp-dev
    binary package. (LP: #2029431)

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Wed, 16 Aug 2023 14:36:41 -0300

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: libslirp
 Section: net
 Priority: optional
-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
 Uploaders: Michael Tokarev <mjt@tls.msk.ru>
 Build-Depends: debhelper-compat (= 13), libglib2.0-dev, meson, ninja-build
-Standards-Version: 4.6.0
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://gitlab.freedesktop.org/slirp/libslirp
 Vcs-Browser: https://salsa.debian.org/qemu-team/libslirp

## libslirp 4.9.1

=== meson_options.txt ===
option('version_suffix', type: 'string', value: '',
       description: 'Suffix to append to SLIRP_VERSION_STRING')

option('oss-fuzz', type : 'boolean', value : false,
       description : 'build against oss-fuzz')

option('llvm-fuzz', type : 'boolean', value : false,
       description : 'build against LLVM libFuzzer')

option('fuzz-reproduce', type : 'boolean', value : false,
       description : 'build a standalone executable to reproduce fuzz cases')

option('static', type : 'boolean', value : false,
       description : 'build static binary, only for debugging, otherwise rather use --default-library static')

option('target_winver', type : 'string', value: '',
       description : 'Target Windows version (default is Windows 7/0x0601)')

=== debian/changelog ===
libslirp (4.9.1-1) unstable; urgency=medium

  * new upstream release

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 09 Sep 2025 22:50:03 +0300

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libslirp
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
+Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
 Uploaders: Michael Tokarev <mjt@tls.msk.ru>
 Build-Depends: debhelper-compat (= 13), libglib2.0-dev, meson, ninja-build
 Standards-Version: 4.7.0

=== debian/rules ===
#! /usr/bin/make -f

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

build-arch build-indep build clean install-indep install-arch install binary-arch binary-indep binary: %:
	dh $@ --buildsystem=meson+ninja

=== debian/watch ===
version=4
opts="searchmode=plain" \
 https://gitlab.freedesktop.org/slirp/@PACKAGE@/tags?sort=updated_desc -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
